Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# osg::StateAttribute Class Reference

Base class for state attributes. More...

Inheritance diagram for osg::StateAttribute:

[legend]
List of all members.

## Public Types
typedef GLenum | GLMode
| GLMode is the value used in glEnable/glDisable(mode).
typedef unsigned int | GLModeValue
| GLModeValue is used to specify whether a mode is enabled (ON) or disabled (OFF).
typedef unsigned int | OverrideValue
| Override is used to specify the override behavior of StateAttributes from parent to children.
typedef std::pair< Type, unsigned int > | TypeMemberPair
| Simple pairing between an attribute type and the member within that attribute type group.
typedef std::vector< StateSet * > | ParentList
| A vector of osg::StateSet pointers which is used to store the parent(s) of this StateAttribute.
enum | Values { OFF = 0x0, ON = 0x1, OVERRIDE = 0x2, PROTECTED = 0x4, INHERIT = 0x8 }
| list values which can be used to set either GLModeValues or OverrideValues. More...
enum | Type { TEXTURE, POLYGONMODE, POLYGONOFFSET, MATERIAL, ALPHAFUNC, ANTIALIAS, COLORTABLE, CULLFACE, FOG, FRONTFACE, LIGHT, POINT, LINEWIDTH, LINESTIPPLE, POLYGONSTIPPLE, SHADEMODEL, TEXENV, TEXENVFILTER, TEXGEN, TEXMAT, LIGHTMODEL, BLENDFUNC, BLENDEQUATION, LOGICOP, STENCIL, COLORMASK, DEPTH, VIEWPORT, SCISSOR, BLENDCOLOR, MULTISAMPLE, CLIPPLANE, COLORMATRIX, VERTEXPROGRAM, FRAGMENTPROGRAM, POINTSPRITE, PROGRAM, VALIDATOR, VIEWMATRIXEXTRACTOR, OSGNV_PARAMETER_BLOCK, OSGNVEXT_TEXTURE_SHADER, OSGNVEXT_VERTEX_PROGRAM, OSGNVEXT_REGISTER_COMBINERS, OSGNVCG_PROGRAM, OSGNVSLANG_PROGRAM, OSGNVPARSE_PROGRAM_PARSER }
| Values of StateAttribute::Type used to aid identification of different StateAttribute subclasses. More...
## Public Member Functions
| StateAttribute ()
| StateAttribute (const StateAttribute &sa, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const=0
| Clone the type of an attribute, with Object* return type.
virtual Object * | clone (const CopyOp &) const=0
| Clone an attribute, with Object* return type.
virtual bool | isSameKindAs (const Object *obj) const
| Return true if this and obj are of the same kind of object.
virtual const char * | libraryName () const
| Return the name of the attribute's library.
virtual const char * | className () const
| Return the name of the attribute's class type.
virtual Type | getType () const=0
| Return the Type identifier of the attribute's class type.
virtual unsigned int | getMember () const
| Return the member identifier within the attribute's class type.
TypeMemberPair | getTypeMemberPair () const
| Return the TypeMemberPair that uniquely identifies this type member.
virtual bool | isTextureAttribute () const
| Return true if StateAttribute is a type which controls texturing and needs to be issued w.r.t to specific texture unit.
virtual int | compare (const StateAttribute &sa) const=0
| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.
bool | operator< (const StateAttribute &rhs) const
bool | operator== (const StateAttribute &rhs) const
bool | operator!= (const StateAttribute &rhs) const
const ParentList & | getParents () const
| Get the parent list of this StateAttribute.
StateSet * | getParent (unsigned int i)
const StateSet * | getParent (unsigned int i) const
| Get a single const parent of this StateAttribute.
unsigned int | getNumParents () const
| Get the number of parents of this StateAttribute.
virtual bool | getModeUsage (ModeUsage &) const
| Return the modes associated with this StateAttribute.
void | setUpdateCallback (Callback *uc)
| Set the UpdateCallback which allows users to attach customize the updating of an object during the update traversal.
Callback * | getUpdateCallback ()
| Get the non const UpdateCallback.
const Callback * | getUpdateCallback () const
| Get the const UpdateCallback.
void | setEventCallback (Callback *ec)
| Set the EventCallback which allows users to attach customize the updating of an object during the Event traversal.
Callback * | getEventCallback ()
| Get the non const EventCallback.
const Callback * | getEventCallback () const
| Get the const EventCallback.
virtual void | apply (State &) const=0
| apply the OpenGL state attributes.
virtual void | compileGLObjects (State &) const
| default to nothing to compile - all state is applied immediately.
virtual void | releaseGLObjects (State *=0) const
| release OpenGL objects in specified graphics context if State object is passed, otherwise release OpenGL objexts for all graphics context if State object pointer NULL.
## Protected Member Functions
virtual | ~StateAttribute ()
void | addParent (osg::StateSet *object)
void | removeParent (osg::StateSet *object)
## Protected Attributes
ParentList | _parents
ref_ptr< Callback > | _updateCallback
ref_ptr< Callback > | _eventCallback

## Detailed Description

Base class for state attributes.

## Member Typedef Documentation

typedef GLenum osg::StateAttribute::GLMode

| GLMode is the value used in glEnable/glDisable(mode).

typedef unsigned int osg::StateAttribute::GLModeValue

| GLModeValue is used to specify whether a mode is enabled (ON) or disabled (OFF). GLMoveValue is also used to specify the override behavior of modes from parent to children. See enum Value description for more details.

typedef unsigned int osg::StateAttribute::OverrideValue

| Override is used to specify the override behavior of StateAttributes from parent to children. See enum Value description for more details.

typedef std::vector<StateSet*> osg::StateAttribute::ParentList

| A vector of osg::StateSet pointers which is used to store the parent(s) of this StateAttribute.

typedef std::pair<Type,unsigned int> osg::StateAttribute::TypeMemberPair

| Simple pairing between an attribute type and the member within that attribute type group.

## Member Enumeration Documentation

enum osg::StateAttribute::Type

  | Values of StateAttribute::Type used to aid identification of different StateAttribute subclasses. Each subclass defines its own value in the virtual Type getType() method. When extending the osg's StateAttribute's simply define your own Type value which is unique, using the StateAttribute::Type enum as a guide of what values to use. If your new subclass needs to override a standard StateAttriubte then simply use that type's value. Enumeration values:
  TEXTURE |
  POLYGONMODE |
  POLYGONOFFSET |
  MATERIAL |
  ALPHAFUNC |
  ANTIALIAS |
  COLORTABLE |
  CULLFACE |
  FOG |
  FRONTFACE |
  LIGHT |
  POINT |
  LINEWIDTH |
  LINESTIPPLE |
  POLYGONSTIPPLE |
  SHADEMODEL |
  TEXENV |
  TEXENVFILTER |
  TEXGEN |
  TEXMAT |
  LIGHTMODEL |
  BLENDFUNC |
  BLENDEQUATION |
  LOGICOP |
  STENCIL |
  COLORMASK |
  DEPTH |
  VIEWPORT |
  SCISSOR |
  BLENDCOLOR |
  MULTISAMPLE |
  CLIPPLANE |
  COLORMATRIX |
  VERTEXPROGRAM |
  FRAGMENTPROGRAM |
  POINTSPRITE |
  PROGRAM | core GLSL support
  VALIDATOR | osgFX namespace
  VIEWMATRIXEXTRACTOR |
  OSGNV_PARAMETER_BLOCK | osgNV namespace
  OSGNVEXT_TEXTURE_SHADER |
  OSGNVEXT_VERTEX_PROGRAM |
  OSGNVEXT_REGISTER_COMBINERS |
  OSGNVCG_PROGRAM | osgNVCg namespace
  OSGNVSLANG_PROGRAM |
  OSGNVPARSE_PROGRAM_PARSER |

enum osg::StateAttribute::Values

  | list values which can be used to set either GLModeValues or OverrideValues. When using in conjunction with GLModeValues, all Values have meaning. When using in conjection with StateAttribute OverrideValue only OFF,OVERRIDE and INHERIT are meaningful. However, they are useful when using GLModeValue and OverrideValue in conjunction with each other as when using StateSet::setAttributeAndModes(..). Enumeration values:
  OFF | means that associated GLMode and Override is disabled.
  ON | means that associated GLMode is enabled and Override is disabled.
  OVERRIDE | Overriding of GLMode's or StateAttributes is enabled, so that state below it is overridden.
  PROTECTED | Protecting of GLMode's or StateAttributes is enabled, so that state from above cannot override this and below state.
  INHERIT | means that GLMode or StateAttribute should be inherited from above.

## Constructor & Destructor Documentation

osg::StateAttribute::StateAttribute | ( |  | ) | `[inline]`

osg::StateAttribute::StateAttribute | ( | const StateAttribute & | sa,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY
| ) | `[inline]`

virtual osg::StateAttribute::~StateAttribute | ( |  | ) | `[inline, protected, virtual]`

## Member Function Documentation

void osg::StateAttribute::addParent | ( | osg::StateSet * | object | ) | `[protected]`

virtual void osg::StateAttribute::apply | ( | State & |  | ) | const`[pure virtual]`

| apply the OpenGL state attributes. The global state for the current OpenGL context is passed in to allow the StateAttribute to obtain details on the the current context and state. Implemented in osg::AlphaFunc, osg::BlendColor, osg::BlendEquation, osg::BlendFunc, osg::ClipPlane, osg::ColorMask, osg::ColorMatrix, osg::CullFace, osg::Depth, osg::Fog, osg::FragmentProgram, osg::FrameBufferObject, osg::FrontFace, osg::Light, osg::LightModel, osg::LineStipple, osg::LineWidth, osg::LogicOp, osg::Material, osg::Multisample, osg::Point, osg::PointSprite, osg::PolygonMode, osg::PolygonOffset, osg::PolygonStipple, osg::Program, osg::Scissor, osg::ShadeModel, osg::Stencil, osg::TexEnv, osg::TexEnvCombine, osg::TexEnvFilter, osg::TexGen, osg::TexMat, osg::Texture, osg::Texture1D, osg::Texture2D, osg::Texture3D, osg::TextureCubeMap, osg::TextureRectangle, osg::VertexProgram, osg::Viewport, osgFX::Validator, and osgText::Font::GlyphTexture.

virtual const char* osg::StateAttribute::className | ( |  | ) | const`[inline, virtual]`

| Return the name of the attribute's class type. Implements osg::Object. Reimplemented in osg::Texture, and osgText::Font::GlyphTexture.

virtual Object* osg::StateAttribute::clone | ( | const CopyOp & |  | ) | const`[pure virtual]`

| Clone an attribute, with Object* return type. Must be defined by derived classes. Implements osg::Object. Implemented in osg::Texture.

virtual Object* osg::StateAttribute::cloneType | ( |  | ) | const`[pure virtual]`

| Clone the type of an attribute, with Object* return type. Must be defined by derived classes. Implements osg::Object. Implemented in osg::Texture.

virtual int osg::StateAttribute::compare | ( | const StateAttribute & | sa | ) | const`[pure virtual]`

| Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs. Implemented in osg::AlphaFunc, osg::BlendColor, osg::BlendEquation, osg::BlendFunc, osg::ClipPlane, osg::ColorMask, osg::ColorMatrix, osg::CullFace, osg::Depth, osg::Fog, osg::FrameBufferObject, osg::FrontFace, osg::Light, osg::LightModel, osg::LineStipple, osg::LineWidth, osg::LogicOp, osg::Material, osg::Multisample, osg::Point, osg::PointSprite, osg::PolygonMode, osg::PolygonOffset, osg::PolygonStipple, osg::Scissor, osg::ShadeModel, osg::Stencil, osg::TexEnv, osg::TexEnvCombine, osg::TexEnvFilter, osg::TexGen, osg::TexMat, osg::Texture1D, osg::Texture2D, osg::Texture3D, osg::TextureCubeMap, osg::TextureRectangle, and osg::Viewport.

virtual void osg::StateAttribute::compileGLObjects | ( | State & |  | ) | const`[inline, virtual]`

| default to nothing to compile - all state is applied immediately. Reimplemented in osg::FragmentProgram, osg::Program, osg::Texture, osg::VertexProgram, and osgFX::Validator.

const Callback* osg::StateAttribute::getEventCallback | ( |  | ) | const`[inline]`

| Get the const EventCallback.

Callback* osg::StateAttribute::getEventCallback | ( |  | ) | `[inline]`

| Get the non const EventCallback.

virtual unsigned int osg::StateAttribute::getMember | ( |  | ) | const`[inline, virtual]`

| Return the member identifier within the attribute's class type. Used for light number/clip plane number etc. Reimplemented in osg::ClipPlane, and osg::Light.

virtual bool osg::StateAttribute::getModeUsage | ( | ModeUsage & |  | ) | const`[inline, virtual]`

| Return the modes associated with this StateAttribute. Reimplemented in osg::AlphaFunc, osg::BlendColor, osg::BlendEquation, osg::BlendFunc, osg::ClipPlane, osg::CullFace, osg::Depth, osg::Fog, osg::FragmentProgram, osg::Light, osg::LineStipple, osg::LogicOp, osg::Material, osg::Point, osg::PointSprite, osg::PolygonOffset, osg::PolygonStipple, osg::Scissor, osg::Stencil, osg::TexGen, osg::Texture, and osg::VertexProgram.

unsigned int osg::StateAttribute::getNumParents | ( |  | ) | const`[inline]`

| Get the number of parents of this StateAttribute. Returns: the number of parents of this StateAttribute.

const StateSet* osg::StateAttribute::getParent | ( | unsigned int | i | ) | const`[inline]`

  | Get a single const parent of this StateAttribute. Parameters:
  i | index of the parent to get.
Returns: the parent i.

StateSet* osg::StateAttribute::getParent | ( | unsigned int | i | ) | `[inline]`

const ParentList& osg::StateAttribute::getParents | ( |  | ) | const`[inline]`

| Get the parent list of this StateAttribute.

virtual Type osg::StateAttribute::getType | ( |  | ) | const`[pure virtual]`

| Return the Type identifier of the attribute's class type. Implemented in osg::Texture.

TypeMemberPair osg::StateAttribute::getTypeMemberPair | ( |  | ) | const`[inline]`

| Return the TypeMemberPair that uniquely identifies this type member.

const Callback* osg::StateAttribute::getUpdateCallback | ( |  | ) | const`[inline]`

| Get the const UpdateCallback.

Callback* osg::StateAttribute::getUpdateCallback | ( |  | ) | `[inline]`

| Get the non const UpdateCallback.

virtual bool osg::StateAttribute::isSameKindAs | ( | const Object * | obj | ) | const`[inline, virtual]`

| Return true if this and obj are of the same kind of object. Reimplemented from osg::Object.

virtual bool osg::StateAttribute::isTextureAttribute | ( |  | ) | const`[inline, virtual]`

| Return true if StateAttribute is a type which controls texturing and needs to be issued w.r.t to specific texture unit. Reimplemented in osg::PointSprite, osg::TexEnv, osg::TexEnvCombine, osg::TexEnvFilter, osg::TexGen, osg::TexMat, and osg::Texture.

virtual const char* osg::StateAttribute::libraryName | ( |  | ) | const`[inline, virtual]`

| Return the name of the attribute's library. Implements osg::Object. Reimplemented in osg::Texture.

bool osg::StateAttribute::operator!= | ( | const StateAttribute & | rhs | ) | const`[inline]`

bool osg::StateAttribute::operator< | ( | const StateAttribute & | rhs | ) | const`[inline]`

bool osg::StateAttribute::operator== | ( | const StateAttribute & | rhs | ) | const`[inline]`

virtual void osg::StateAttribute::releaseGLObjects | ( | State * | = 0 | ) | const`[inline, virtual]`

| release OpenGL objects in specified graphics context if State object is passed, otherwise release OpenGL objexts for all graphics context if State object pointer NULL. Reimplemented from osg::Object. Reimplemented in osg::FragmentProgram, osg::Program, osg::Texture, and osg::VertexProgram.

void osg::StateAttribute::removeParent | ( | osg::StateSet * | object | ) | `[protected]`

void osg::StateAttribute::setEventCallback | ( | Callback * | ec | ) |

| Set the EventCallback which allows users to attach customize the updating of an object during the Event traversal.

void osg::StateAttribute::setUpdateCallback | ( | Callback * | uc | ) |

| Set the UpdateCallback which allows users to attach customize the updating of an object during the update traversal.

## Member Data Documentation

ref_ptr<Callback> osg::StateAttribute::_eventCallback`[protected]`

ParentList osg::StateAttribute::_parents`[protected]`

ref_ptr<Callback> osg::StateAttribute::_updateCallback`[protected]`

The documentation for this class was generated from the following file:

- StateAttribute